package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[DALog] 数据对象
 */
@TableName(value = "T_SRFDALOG",resultMap = "DALogResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class DALog extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @TableId(value= "dalog_id",type=IdType.UUID)//指定主键生成策略
    private String dalog_id;
    private String dalog_name;
    private String loginfo;
    private Integer logsn;
    @Dict(dictName = "ionicdemo_CodeList24CodeList")
    private String logtype;
    private String objectid;
    private String objecttype;
    private String remoteaddr;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    /**
     *  设置属性值[日志时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[日志时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[日志时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[DA日志标识]
     *  @param dalog_id
     */
    public void setDalog_id(String dalog_id){
        if(StringUtils.isEmpty(dalog_id))
            dalog_id=null;
        this.dalog_id = dalog_id;
        this.set("dalog_iddirtyflag",true);
    }
    /**
     *  获取属性值[DA日志标识]
     */
    public String getDalog_id(){
        return this.dalog_id;
    }
    /**
     *  重置属性值[DA日志标识]
     */
    public void resetDalog_id(){
        this.set("dalog_iddirtyflag",false);
        this.dalog_id = null;
    }
    /**
     *  设置属性值[DA日志名称]
     *  @param dalog_name
     */
    public void setDalog_name(String dalog_name){
        if(StringUtils.isEmpty(dalog_name))
            dalog_name=null;
        this.dalog_name = dalog_name;
        this.set("dalog_namedirtyflag",true);
    }
    /**
     *  获取属性值[DA日志名称]
     */
    public String getDalog_name(){
        return this.dalog_name;
    }
    /**
     *  重置属性值[DA日志名称]
     */
    public void resetDalog_name(){
        this.set("dalog_namedirtyflag",false);
        this.dalog_name = null;
    }
    /**
     *  设置属性值[日志信息]
     *  @param loginfo
     */
    public void setLoginfo(String loginfo){
        if(StringUtils.isEmpty(loginfo))
            loginfo=null;
        this.loginfo = loginfo;
        this.set("loginfodirtyflag",true);
    }
    /**
     *  获取属性值[日志信息]
     */
    public String getLoginfo(){
        return this.loginfo;
    }
    /**
     *  重置属性值[日志信息]
     */
    public void resetLoginfo(){
        this.set("loginfodirtyflag",false);
        this.loginfo = null;
    }
    /**
     *  设置属性值[日志序列]
     *  @param logsn
     */
    public void setLogsn(Integer logsn){
        this.logsn = logsn;
        this.set("logsndirtyflag",true);
    }
    /**
     *  获取属性值[日志序列]
     */
    public Integer getLogsn(){
        return this.logsn;
    }
    /**
     *  重置属性值[日志序列]
     */
    public void resetLogsn(){
        this.set("logsndirtyflag",false);
        this.logsn = null;
    }
    /**
     *  设置属性值[日志类型]
     *  @param logtype
     */
    public void setLogtype(String logtype){
        if(StringUtils.isEmpty(logtype))
            logtype=null;
        this.logtype = logtype;
        this.set("logtypedirtyflag",true);
    }
    /**
     *  获取属性值[日志类型]
     */
    public String getLogtype(){
        return this.logtype;
    }
    /**
     *  重置属性值[日志类型]
     */
    public void resetLogtype(){
        this.set("logtypedirtyflag",false);
        this.logtype = null;
    }
    /**
     *  设置属性值[对象标识]
     *  @param objectid
     */
    public void setObjectid(String objectid){
        if(StringUtils.isEmpty(objectid))
            objectid=null;
        this.objectid = objectid;
        this.set("objectiddirtyflag",true);
    }
    /**
     *  获取属性值[对象标识]
     */
    public String getObjectid(){
        return this.objectid;
    }
    /**
     *  重置属性值[对象标识]
     */
    public void resetObjectid(){
        this.set("objectiddirtyflag",false);
        this.objectid = null;
    }
    /**
     *  设置属性值[对象类型]
     *  @param objecttype
     */
    public void setObjecttype(String objecttype){
        if(StringUtils.isEmpty(objecttype))
            objecttype=null;
        this.objecttype = objecttype;
        this.set("objecttypedirtyflag",true);
    }
    /**
     *  获取属性值[对象类型]
     */
    public String getObjecttype(){
        return this.objecttype;
    }
    /**
     *  重置属性值[对象类型]
     */
    public void resetObjecttype(){
        this.set("objecttypedirtyflag",false);
        this.objecttype = null;
    }
    /**
     *  设置属性值[远程地址]
     *  @param remoteaddr
     */
    public void setRemoteaddr(String remoteaddr){
        if(StringUtils.isEmpty(remoteaddr))
            remoteaddr=null;
        this.remoteaddr = remoteaddr;
        this.set("remoteaddrdirtyflag",true);
    }
    /**
     *  获取属性值[远程地址]
     */
    public String getRemoteaddr(){
        return this.remoteaddr;
    }
    /**
     *  重置属性值[远程地址]
     */
    public void resetRemoteaddr(){
        this.set("remoteaddrdirtyflag",false);
        this.remoteaddr = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetDalog_id();
        resetDalog_name();
        resetLoginfo();
        resetLogsn();
        resetLogtype();
        resetObjectid();
        resetObjecttype();
        resetRemoteaddr();
        resetUpdatedate();
        resetUpdateman();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public DALog copyTo(DALog targetEntity)
	{
		BeanCopier copier=BeanCopier.create(DALog.class, DALog.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetDalog_id();
		return targetEntity;
	}
}